<?php
if( substr( $_SERVER["HTTP_USER_AGENT"], 0, 11 ) != 'UniUploader' ){
    die("You can't access this file directly... Please go to main Page.");
}

define("IN_ROSTER", true);

$versions['versionDate']['update'] = '$Date: 2006/02/03 14:16:39 $'; 
$versions['versionRev']['update'] = '$Revision: 1.23 $'; 
$versions['versionAuthor']['update'] = '$Author: anthonyb $';

chdir('../../');
$subdir = '';
require_once $subdir.'conf.php';
include $subdir.'lib/luaparser.php';
include $subdir.'lib/wowdb.php';



// Update Triggers
if( $use_update_triggers )
	include( $subdir.'lib/update_trigger_lib.php' );

// Connect to the db
	$wowdb->connect( $db_host, $db_user, $db_passwd, $db_name );
// Set the sql debugger (outputs html comments of sql strings in addition to normal output)
	$wowdb->setSQLDebug($sqldebug);

include $subdir.'lib/uninuke.php';

$header = '<font color="#FFFFFF">'.$updMember[$roster_lang].'</font><br />'."\n";


$filefields[0] = 'CharacterProfiler';
$filefields[1] = 'PvPLog';

foreach ($_FILES as $filefield => $file)
{
	if (substr_count($file['name'],'.gz') > 0)	// If the file is gzipped
	{
		$filename = $file['tmp_name'];
		$tempHandle = gzopen($filename, 'r');			// Uncompress
		$contents = fread($tempHandle,5000000);		// Read up to 5 megs (no way to see total uncompressed length :( )
		fclose($tempHandle);
		$tmpfname = tempnam('','luatemp');				// Create temp file for uncompressed data
		$handle = fopen($tmpfname, 'w');
		fwrite($handle, $contents);								// Write the uncompressed temp file
		fclose($handle);
		$filename = $tmpfname;										// Return the filename (with full path)
	}
	else		// The file is not gzipped
	{
		$filename = $file['tmp_name'];
	}

	for ($i = 0; $i < count($filefields); $i++)	// Itterate through all the possible filefields
	{
		if ($filefields[$i] == $filefield)
		{
			// Filefield is 1 of the 4 we accept.
			$uploadFound = true;
			if ($authenticated_user)
			{
				$data = lua_parse( $filename );

				// If pvp data is there, assign it to $pvpdata
				if (isset($data['PurgeLogData']))
				{
					$pvpdata = $data;
				}

				// If CP data is there, assign it to $myProfile
				if (isset($data['myProfile']))
				{
					$myProfile = $data['myProfile'];
				}
			}
		}
	}
	@unlink($filename);	// Done with the file, dont need it anymore
}

if(isset($_POST['update_trigger']) && $_POST['update_trigger'] == '1')
{
	$run_trigger = 1;
}

// If the roster update password is sent and matches, and $myprofile is there, update the roster
if(isset($_POST['roster_update_password']) && $_POST['roster_update_password'] == $roster_upd_pw && isset( $myProfile ))
{
	$rosterUpdateMessages = processGuildRoster($myProfile);
}

if( isset( $myProfile ) )
{
	$updateMessages = processMyProfile($myProfile);
}

if( isset($pvpdata))
{
	$updatePvPMessages = processPvP($pvpdata);
}

function processPvP($pvpdata)
{
	global $wowdb, $minPvPLogver, $wordings, $roster_lang;
	foreach ($pvpdata['PurgeLogData'] as $realm_name => $realm)
	{
		foreach ($realm as $char_name => $char)
		{
			$query = "SELECT `guild_id` FROM `".ROSTER_PLAYERSTABLE."` WHERE `name` = '".addslashes($char_name)."' AND `server` = '".addslashes($realm_name)."'";
			$result = $wowdb->query( $query );
			if (mysql_num_rows($result) > 0)
			{
				$row = $wowdb->getrow( $result );
				$guild_id = $row['guild_id'];
				$battles = $char['battles'];
				if( $char['version'] >= $minPvPLogver )
				{
					$output .= "Updating PvP Data for [$char_name]<br />\n";
					$output .= $wowdb->update_pvp2($guild_id, $char_name, $battles);
				}
				else // PvPLog version not high enough
				{
					$output .= "<span style=\"color:#FF0000;\">NOT Updating PvP for [$char_name] - $PvPver</span><br />\n".$wordings[$roster_lang]['PvPLogver_err']."<br />\n<br />\n";
				}
			}
		}
	}
	return $output;
}

function processMyProfile($myProfile)
{
	global $wowdb, $server_name, $guild_name, $use_update_triggers, $minCPver, $wordings, $roster_lang;

	foreach( array_keys( $myProfile ) as $realm_name )
	{
		$realm = $myProfile[$realm_name];
		foreach( array_keys( $realm ) as $char_name )
		{
			if ($char_name != 'Guild')
			{
				if ($server_name == $realm_name)
				{
					$guildInfoOutput = $wowdb->get_guild_info($realm_name,$guild_name);
					$guildInfo = $guildInfoOutput[1];
					$output .= $guildInfoOutput[0];
					if ($guildInfo)
					{
						$char = $realm[$char_name];

						// CP Version Detection, don't allow lower than minVer
						if( $char['CPversion'] >= $minCPver )
						{
							$output .= "Updating character [$char_name]<br />\n";
							$output .= $wowdb->update_char( $guildInfo['guild_id'], $char_name, $char );
	
							// Start update triggers
							if( $use_update_triggers )
							{
								$output .= start_update_trigger($char_name,'char');
							}
						}
						else // CP Version not new enough
						{
							$output .= "<span style=\"color:#FF0000;\">NOT Updating character [$char_name]<br />\nData extract is from CharacterProfiler v".$char['CPversion']."</span><br />\n".$wordings[$roster_lang]['CPver_err']."<br />\n<br />\n";
						}
					}
					else
					{
						$output .= $noGuild[$roster_lang];
					}
				}
			}
		}
	}
	return $output;
}

function processGuildRoster($myProfile)
{
	global $wowdb, $server_name, $guild_name, $run_trigger, $use_update_triggers, $minGPver, $wordings, $roster_lang;

	if (!empty($myProfile))
	{
		foreach(array_keys($myProfile) as $realm_name)
		{
			$realm = $myProfile[$realm_name];
			$guild = $realm['Guild'];
			if($guild)
			{
				$guildName = $guild['Guild'];
				if($guild_name == $guildName)
				{
					// GP Version Detection, don't allow lower than minVer
					if( $guild['GPversion'] >= $minGPver )
					{
						$guildMotd = $guild['Motd'];
						$guildNumMembers = $guild['NumMembers'];
						$guildDateUpdatedUTC = $guild['DateUTC'];
						$guildFaction = $guild['Faction'];
						$GPversion = $guild['GPversion'];

						// make hour between 0 and 23 and minute between 0 and 60
						$guildHour= intval($guild['Hour']);
						$guildMinute= intval($guild['Minute']);

						// take the current time and get the offset. Upload must occur same day that roster was obtained
						$currentTimestamp = mktime($guildHour,$guildMinute,0);
						$currentTime = getDate($currentTimestamp);
						$output .= "Updating Guild [ $guildName ]<br />\n";

						// $guildId = $wowdb->update_guild($realm_name, $guildName, $guildMotd, $guildNumMembers, $currentTime, $guildDateUpdatedUTC);
						$updGuildOutput = $wowdb->update_guild($realm_name, $guildName, $guildFaction, $guildMotd, $guildNumMembers, $currentTime, $guildDateUpdatedUTC, $GPversion);
						$output .= $updGuildOutput[0];
						$guildId = $updGuildOutput[1];
						$guildMembers = $guild['Members'];

						// update the list of guild members
						foreach(array_keys($guildMembers) as $char_name)
						{
							$char = $guildMembers[$char_name];
							$output .= $wowdb->update_guild_member($guildId, $char_name, $char, $currentTimestamp);

							// Start update triggers
							if( $run_trigger && $use_update_triggers )
							{
								$output .= start_update_trigger($char_name,'guild');
							}
						}
						// Remove the members who were not in this list
						$output .= $wowdb->remove_guild_members($guildId, $currentTime);
						$output .= $wowdb->remove_guild_members_id($guildId);
					}
					else
					// GP Version not new enough
					{
						$output .= "<span style=\"color:#FF0000;\">NOT Updating Guild list for $guildName<br />\nData extract is from GuildProfiler v".$guild['GPversion']."</span><br />\n".$wordings[$roster_lang]['GPver_err']."<br />\n<br />\n";
					}
				}	
				else
				{
					$output .= $guild_nameNotFound[$roster_lang];
				}
			}
		}
	}
	return $output;
}


// Construct our page

	if ($uploadFound)
	{
		print

		$auth_message.'<br /><br />'.
		$updateMessages.'<br /><br />'.
		$updatePvPMessages.'<br /><br />'.
		$rosterUpdateMessages;

	}
	else
	{
		// Weren't any files in the upload that correspond to anything in the array of filefields that we take.
		print $nofileUploaded[$roster_lang];
	}


?>
